cfg.mk 44.2 KB
Newer Older
1
# Customize Makefile.maint.                           -*- makefile -*-
2
# Copyright (C) 2008-2014 Red Hat, Inc.
3
# Copyright (C) 2003-2008 Free Software Foundation, Inc.
4 5 6 7 8 9 10 11 12 13 14 15

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
16 17
# along with this program.  If not, see
# <http://www.gnu.org/licenses/>.
18 19 20 21 22 23 24 25 26 27 28

# Use alpha.gnu.org for alpha and beta releases.
# Use ftp.gnu.org for major releases.
gnu_ftp_host-alpha = alpha.gnu.org
gnu_ftp_host-beta = alpha.gnu.org
gnu_ftp_host-major = ftp.gnu.org
gnu_rel_host = $(gnu_ftp_host-$(RELEASE_TYPE))

url_dir_list = \
  ftp://$(gnu_rel_host)/gnu/coreutils

29 30 31
# We use .gnulib, not gnulib.
gnulib_dir = $(srcdir)/.gnulib

E
Eric Blake 已提交
32 33 34
# List of additional files that we want to pick up in our POTFILES.in
# This is all gnulib files, as well as generated files for RPC code.
generated_files = \
E
Eric Blake 已提交
35
  $(srcdir)/daemon/*_dispatch.h \
E
Eric Blake 已提交
36
  $(srcdir)/src/*/*_dispatch.h \
E
Eric Blake 已提交
37
  $(srcdir)/src/remote/*_client_bodies.h \
E
Eric Blake 已提交
38
  $(srcdir)/src/*/*_protocol.[ch] \
E
Eric Blake 已提交
39 40
  $(srcdir)/gnulib/lib/*.[ch]

E
Eric Blake 已提交
41 42 43
# We haven't converted all scripts to using gnulib's init.sh yet.
_test_script_regex = \<\(init\|test-lib\)\.sh\>

44 45
# Tests not to run as part of "make distcheck".
local-checks-to-skip =			\
46
  changelog-check			\
47
  makefile-check			\
48 49
  makefile_path_separator_check		\
  patch-check				\
50 51 52
  sc_GPL_version			\
  sc_always_defined_macros		\
  sc_cast_of_alloca_return_value	\
53
  sc_cross_check_PATH_usage_in_tests	\
54 55 56
  sc_dd_max_sym_length			\
  sc_error_exit_success			\
  sc_file_system			\
57 58
  sc_immutable_NEWS			\
  sc_makefile_path_separator_check	\
59
  sc_obsolete_symbols			\
60
  sc_prohibit_S_IS_definition		\
61
  sc_prohibit_atoi_atof			\
62
  sc_prohibit_hash_without_use		\
63 64 65
  sc_prohibit_jm_in_m4			\
  sc_prohibit_quote_without_use		\
  sc_prohibit_quotearg_without_use	\
66
  sc_prohibit_stat_st_blocks		\
67 68 69 70
  sc_root_tests				\
  sc_space_tab				\
  sc_sun_os_names			\
  sc_system_h_headers			\
E
Eric Blake 已提交
71
  sc_texinfo_acronym			\
72
  sc_tight_scope			\
73
  sc_two_space_separator_in_usage	\
J
Jim Meyering 已提交
74 75 76 77
  sc_error_message_uppercase		\
  sc_program_name			\
  sc_require_test_exit_idiom		\
  sc_makefile_check			\
78
  sc_useless_cpp_parens
79

80 81 82 83 84 85 86 87
# Most developers don't run 'make distcheck'.  We want the official
# dist to be secure, but don't want to penalize other developers
# using a distro that has not yet picked up the automake fix.
# FIXME remove this ifeq (making the syntax check unconditional)
# once fixed automake (1.11.6 or 1.12.2+) is more common.
ifeq ($(filter dist%, $(MAKECMDGOALS)), )
local-checks-to-skip +=	sc_vulnerable_makefile_CVE-2012-3386
else
88
distdir: sc_vulnerable_makefile_CVE-2012-3386.z
89 90
endif

91
# Files that should never cause syntax check failures.
92
VC_LIST_ALWAYS_EXCLUDE_REGEX = \
93
  (^(HACKING|docs/(news\.html\.in|.*\.patch))|\.(po|fig|gif|ico|png))$$
94 95

# Functions like free() that are no-ops on NULL arguments.
96
useless_free_options =				\
J
John Ferlan 已提交
97 98 99
  --name=VBOX_UTF16_FREE			\
  --name=VBOX_UTF8_FREE				\
  --name=VBOX_COM_UNALLOC_MEM			\
100
  --name=VIR_FREE				\
101
  --name=qemuCapsFree				\
102
  --name=qemuMigrationCookieFree                \
103
  --name=qemuMigrationCookieGraphicsFree        \
104
  --name=sexpr_free				\
105
  --name=usbFreeDevice                          \
106
  --name=virBandwidthDefFree			\
107
  --name=virBitmapFree                          \
108 109 110 111 112 113 114 115 116
  --name=virCPUDefFree				\
  --name=virCapabilitiesFree			\
  --name=virCapabilitiesFreeGuest		\
  --name=virCapabilitiesFreeGuestDomain		\
  --name=virCapabilitiesFreeGuestFeature	\
  --name=virCapabilitiesFreeGuestMachine	\
  --name=virCapabilitiesFreeHostNUMACell	\
  --name=virCapabilitiesFreeMachines		\
  --name=virCgroupFree				\
117
  --name=virCommandFree				\
118 119
  --name=virConfFreeList			\
  --name=virConfFreeValue			\
120
  --name=virDomainActualNetDefFree		\
121
  --name=virDomainChrDefFree			\
122
  --name=virDomainChrSourceDefFree		\
123 124 125 126 127
  --name=virDomainControllerDefFree		\
  --name=virDomainDefFree			\
  --name=virDomainDeviceDefFree			\
  --name=virDomainDiskDefFree			\
  --name=virDomainEventCallbackListFree		\
128 129
  --name=virObjectEventQueueFree		\
  --name=virObjectEventStateFree		\
130 131 132 133 134 135
  --name=virDomainFSDefFree			\
  --name=virDomainGraphicsDefFree		\
  --name=virDomainHostdevDefFree		\
  --name=virDomainInputDefFree			\
  --name=virDomainNetDefFree			\
  --name=virDomainObjFree			\
E
Eric Blake 已提交
136
  --name=virDomainSmartcardDefFree		\
137 138 139 140 141
  --name=virDomainSnapshotDefFree		\
  --name=virDomainSnapshotObjFree		\
  --name=virDomainSoundDefFree			\
  --name=virDomainVideoDefFree			\
  --name=virDomainWatchdogDefFree		\
142
  --name=virFileDirectFdFree			\
143
  --name=virHashFree				\
144 145 146 147 148 149
  --name=virInterfaceDefFree			\
  --name=virInterfaceIpDefFree			\
  --name=virInterfaceObjFree			\
  --name=virInterfaceProtocolDefFree		\
  --name=virJSONValueFree			\
  --name=virLastErrFreeData			\
150
  --name=virNetMessageFree                      \
151 152 153
  --name=virNetServerMDNSFree                   \
  --name=virNetServerMDNSEntryFree              \
  --name=virNetServerMDNSGroupFree              \
154 155 156 157 158
  --name=virNWFilterDefFree			\
  --name=virNWFilterEntryFree			\
  --name=virNWFilterHashTableFree		\
  --name=virNWFilterIPAddrLearnReqFree		\
  --name=virNWFilterIncludeDefFree		\
159
  --name=virNWFilterObjFree			\
160 161 162 163 164
  --name=virNWFilterRuleDefFree			\
  --name=virNWFilterRuleInstFree		\
  --name=virNetworkDefFree			\
  --name=virNodeDeviceDefFree			\
  --name=virNodeDeviceObjFree			\
165 166
  --name=virObjectUnref                         \
  --name=virObjectFreeCallback                  \
167
  --name=virPCIDeviceFree                       \
168 169 170
  --name=virSecretDefFree			\
  --name=virStorageEncryptionFree		\
  --name=virStorageEncryptionSecretFree		\
171
  --name=virStorageFileFreeMetadata		\
172 173 174 175
  --name=virStoragePoolDefFree			\
  --name=virStoragePoolObjFree			\
  --name=virStoragePoolSourceFree		\
  --name=virStorageVolDefFree			\
H
Hu Tao 已提交
176
  --name=virThreadPoolFree			\
177
  --name=xmlBufferFree				\
178
  --name=xmlFree				\
179
  --name=xmlFreeDoc				\
E
Eric Blake 已提交
180
  --name=xmlFreeNode				\
181
  --name=xmlXPathFreeContext			\
182
  --name=xmlXPathFreeObject
183

184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223
# The following template was generated by this command:
# make ID && aid free|grep '^vi'|sed 's/ .*//;s/^/#   /'
# N virBufferFreeAndReset
# y virCPUDefFree
# y virCapabilitiesFree
# y virCapabilitiesFreeGuest
# y virCapabilitiesFreeGuestDomain
# y virCapabilitiesFreeGuestFeature
# y virCapabilitiesFreeGuestMachine
# y virCapabilitiesFreeHostNUMACell
# y virCapabilitiesFreeMachines
# N virCapabilitiesFreeNUMAInfo FIXME
# y virCgroupFree
# N virConfFree               (diagnoses the "error")
# y virConfFreeList
# y virConfFreeValue
# y virDomainChrDefFree
# y virDomainControllerDefFree
# y virDomainDefFree
# y virDomainDeviceDefFree
# y virDomainDiskDefFree
# y virDomainEventCallbackListFree
# y virDomainEventQueueFree
# y virDomainFSDefFree
# n virDomainFree
# n virDomainFreeName (can't fix -- returns int)
# y virDomainGraphicsDefFree
# y virDomainHostdevDefFree
# y virDomainInputDefFree
# y virDomainNetDefFree
# y virDomainObjFree
# y virDomainSnapshotDefFree
# n virDomainSnapshotFree (returns int)
# n virDomainSnapshotFreeName (returns int)
# y virDomainSnapshotObjFree
# y virDomainSoundDefFree
# y virDomainVideoDefFree
# y virDomainWatchdogDefFree
# n virDrvNodeGetCellsFreeMemory (returns int)
# n virDrvNodeGetFreeMemory (returns long long)
E
Eric Blake 已提交
224
# n virFree - dereferences param
225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241
# n virFreeError
# n virHashFree (takes 2 args)
# y virInterfaceDefFree
# n virInterfaceFree (returns int)
# n virInterfaceFreeName
# y virInterfaceIpDefFree
# y virInterfaceObjFree
# n virInterfaceObjListFree
# y virInterfaceProtocolDefFree
# y virJSONValueFree
# y virLastErrFreeData
# y virNWFilterDefFree
# y virNWFilterEntryFree
# n virNWFilterFree (returns int)
# y virNWFilterHashTableFree
# y virNWFilterIPAddrLearnReqFree
# y virNWFilterIncludeDefFree
242 243 244
# n virNWFilterFreeName (returns int)
# y virNWFilterObjFree
# n virNWFilterObjListFree FIXME
245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276
# y virNWFilterRuleDefFree
# n virNWFilterRuleFreeInstanceData (typedef)
# y virNWFilterRuleInstFree
# y virNetworkDefFree
# n virNetworkFree (returns int)
# n virNetworkFreeName (returns int)
# n virNodeDevCapsDefFree FIXME
# y virNodeDeviceDefFree
# n virNodeDeviceFree (returns int)
# y virNodeDeviceObjFree
# n virNodeDeviceObjListFree FIXME
# n virNodeGetCellsFreeMemory (returns int)
# n virNodeGetFreeMemory (returns non-void)
# y virSecretDefFree
# n virSecretFree (returns non-void)
# n virSecretFreeName (2 args)
# n virSecurityLabelDefFree FIXME
# n virStorageBackendDiskMakeFreeExtent (returns non-void)
# y virStorageEncryptionFree
# y virStorageEncryptionSecretFree
# n virStorageFreeType (enum)
# y virStoragePoolDefFree
# n virStoragePoolFree (returns non-void)
# n virStoragePoolFreeName (returns non-void)
# y virStoragePoolObjFree
# n virStoragePoolObjListFree FIXME
# y virStoragePoolSourceFree
# y virStorageVolDefFree
# n virStorageVolFree (returns non-void)
# n virStorageVolFreeName (returns non-void)
# n virStreamFree

277 278 279
# Avoid uses of write(2).  Either switch to streams (fwrite), or use
# the safewrite wrapper.
sc_avoid_write:
E
Eric Blake 已提交
280 281 282
	@prohibit='\<write *\('						\
	in_vc_files='\.c$$'						\
	halt='consider using safewrite instead of write'		\
283
	  $(_sc_search_regexp)
284

285 286 287
# In debug statements, print flags as bitmask and mode_t as octal.
sc_flags_debug:
	@prohibit='\<mode=%[0-9.]*[diux]'				\
288
	halt='use %o to debug mode_t values'				\
289
	  $(_sc_search_regexp)
290 291 292 293 294 295 296 297 298 299 300 301 302
	@prohibit='[Ff]lags=%[0-9.]*l*[diou]'				\
	halt='use %x to debug flag values'				\
	  $(_sc_search_regexp)

# Prefer 'unsigned int flags', along with checks for unknown flags.
# For historical reasons, we are stuck with 'unsigned long flags' in
# migration, so check for those known 4 instances and no more in public
# API.  Also check that no flags are marked unused, and 'unsigned' should
# appear before any declaration of a flags variable (achieved by
# prohibiting the word prior to the type from ending in anything other
# than d).  The existence of long long, and of documentation about
# flags, makes the regex in the third test slightly harder.
sc_flags_usage:
303
	@test "$$(cat $(srcdir)/include/libvirt/libvirt-domain.h	\
304 305
	    $(srcdir)/include/libvirt/virterror.h			\
	    $(srcdir)/include/libvirt/libvirt-qemu.h			\
306
	    $(srcdir)/include/libvirt/libvirt-lxc.h			\
307 308 309 310 311 312 313 314
	  | grep -c '\(long\|unsigned\) flags')" != 4 &&		\
	  { echo '$(ME): new API should use "unsigned int flags"' 1>&2;	\
	    exit 1; } || :
	@prohibit=' flags ''ATTRIBUTE_UNUSED'				\
	halt='flags should be checked with virCheckFlags'		\
	  $(_sc_search_regexp)
	@prohibit='^[^@]*([^d] (int|long long)|[^dg] long) flags[;,)]'	\
	halt='flags should be unsigned'					\
315 316
	  $(_sc_search_regexp)

E
Eric Blake 已提交
317 318
# Avoid functions that should only be called via macro counterparts.
sc_prohibit_internal_functions:
319
	@prohibit='vir(Free|AllocN?|ReallocN|(Insert|Delete)ElementsN|File(Close|Fclose|Fdopen)) *\(' \
E
Eric Blake 已提交
320 321 322
	halt='use VIR_ macros instead of internal functions'		\
	  $(_sc_search_regexp)

E
Eric Blake 已提交
323 324 325
# Avoid raw malloc and free, except in documentation comments.
sc_prohibit_raw_allocation:
	@prohibit='^.[^*].*\<((m|c|re)alloc|free) *\([^)]'		\
326
	halt='use VIR_ macros from viralloc.h instead of malloc/free'	\
E
Eric Blake 已提交
327 328
	  $(_sc_search_regexp)

E
Eric Blake 已提交
329 330
# Avoid functions that can lead to double-close bugs.
sc_prohibit_close:
331
	@prohibit='([^>.]|^)\<[fp]?close *\('				\
E
Eric Blake 已提交
332 333 334 335 336 337
	halt='use VIR_{FORCE_}[F]CLOSE instead of [f]close'		\
	  $(_sc_search_regexp)
	@prohibit='\<fdopen *\('					\
	halt='use VIR_FDOPEN instead of fdopen'				\
	  $(_sc_search_regexp)

338 339 340 341 342 343
# Prefer virCommand for all child processes.
sc_prohibit_fork_wrappers:
	@prohibit='= *\<(fork|popen|system) *\('			\
	halt='use virCommand for child processes'			\
	  $(_sc_search_regexp)

344 345 346 347 348 349
# Prefer mkostemp with O_CLOEXEC.
sc_prohibit_mkstemp:
	@prohibit='[^"]\<mkstemps? *\('					\
	halt='use mkostemp with O_CLOEXEC instead of mkstemp'		\
	  $(_sc_search_regexp)

E
Eric Blake 已提交
350 351 352 353 354 355 356
# access with X_OK accepts directories, but we can't exec() those.
# access with F_OK or R_OK is okay, though.
sc_prohibit_access_xok:
	@prohibit='access''(at)? *\(.*X_OK'				\
	halt='use virFileIsExecutable instead of access''(,X_OK)'	\
	  $(_sc_search_regexp)

E
Eric Blake 已提交
357 358
# Similar to the gnulib maint.mk rule for sc_prohibit_strcmp
# Use STREQLEN or STRPREFIX rather than comparing strncmp == 0, or != 0.
E
Eric Blake 已提交
359
snp_ = strncmp *\(.+\)
E
Eric Blake 已提交
360
sc_prohibit_strncmp:
E
Eric Blake 已提交
361 362
	@prohibit='! *strncmp *\(|\<$(snp_) *[!=]=|[!=]= *$(snp_)'	\
	exclude=':# *define STR(N?EQLEN|PREFIX)\('			\
363
	halt='use STREQLEN or STRPREFIX instead of str''ncmp'		\
E
Eric Blake 已提交
364
	  $(_sc_search_regexp)
365

E
Eric Blake 已提交
366 367 368 369
# strtol and friends are too easy to misuse
sc_prohibit_strtol:
	@prohibit='\bstrto(u?ll?|[ui]max) *\('				\
	exclude='exempt from syntax-check'				\
370
	halt='use virStrToLong_*, not strtol variants'			\
E
Eric Blake 已提交
371 372 373
	  $(_sc_search_regexp)
	@prohibit='\bstrto[df] *\('					\
	exclude='exempt from syntax-check'				\
374
	halt='use virStrToDouble, not strtod variants'			\
E
Eric Blake 已提交
375 376
	  $(_sc_search_regexp)

E
Eric Blake 已提交
377
# Use virAsprintf rather than as'printf since *strp is undefined on error.
E
Eric Blake 已提交
378
# But for plain %s, virAsprintf is overkill compared to strdup.
379
sc_prohibit_asprintf:
E
Eric Blake 已提交
380
	@prohibit='\<v?a[s]printf\>'					\
E
Eric Blake 已提交
381 382
	halt='use virAsprintf, not as'printf				\
	  $(_sc_search_regexp)
E
Eric Blake 已提交
383
	@prohibit='virAsprintf.*, *"%s",'				\
384 385 386 387 388 389
	halt='use VIR_STRDUP instead of virAsprintf with "%s"'		\
	  $(_sc_search_regexp)

sc_prohibit_strdup:
	@prohibit='\<strn?dup\> *\('					\
	halt='use VIR_STRDUP, not strdup'				\
E
Eric Blake 已提交
390
	  $(_sc_search_regexp)
E
Eric Blake 已提交
391

E
Eric Blake 已提交
392 393 394 395 396 397
# Prefer virSetUIDGID.
sc_prohibit_setuid:
	@prohibit='\<set(re)?[ug]id\> *\('				\
	halt='use virSetUIDGID, not raw set*id'				\
	  $(_sc_search_regexp)

398 399 400 401 402 403
# Don't compare *id_t against raw -1.
sc_prohibit_risky_id_promotion:
	@prohibit='\b(user|group|[ug]id) *[=!]= *-'			\
	halt='cast -1 to ([ug]id_t) before comparing against id'	\
	  $(_sc_search_regexp)

E
Eric Blake 已提交
404 405 406 407 408
# Use snprintf rather than s'printf, even if buffer is provably large enough,
# since gnulib has more guarantees for snprintf portability
sc_prohibit_sprintf:
	@prohibit='\<[s]printf\>'					\
	halt='use snprintf, not s'printf				\
E
Eric Blake 已提交
409
	  $(_sc_search_regexp)
410

411
sc_prohibit_readlink:
412
	@prohibit='\<readlink *\('					\
E
Eric Blake 已提交
413 414
	halt='use virFileResolveLink, not readlink'			\
	  $(_sc_search_regexp)
415

416
sc_prohibit_gethostname:
E
Eric Blake 已提交
417 418 419
	@prohibit='gethostname *\('					\
	halt='use virGetHostname, not gethostname'			\
	  $(_sc_search_regexp)
420

E
Eric Blake 已提交
421 422 423 424 425 426
sc_prohibit_readdir:
	@prohibit='\breaddir *\('					\
	exclude='exempt from syntax-check'				\
	halt='use virDirRead, not readdir'				\
	  $(_sc_search_regexp)

E
Eric Blake 已提交
427
sc_prohibit_gettext_noop:
E
Eric Blake 已提交
428 429 430
	@prohibit='gettext_noop *\('					\
	halt='use N_, not gettext_noop'					\
	  $(_sc_search_regexp)
E
Eric Blake 已提交
431

432
sc_prohibit_VIR_ERR_NO_MEMORY:
E
Eric Blake 已提交
433 434 435
	@prohibit='\<V''IR_ERR_NO_MEMORY\>'				\
	halt='use virReportOOMError, not V'IR_ERR_NO_MEMORY		\
	  $(_sc_search_regexp)
436

437 438 439 440 441
sc_prohibit_PATH_MAX:
	@prohibit='\<P''ATH_MAX\>'				\
	halt='dynamically allocate paths, do not use P'ATH_MAX	\
	  $(_sc_search_regexp)

E
Eric Blake 已提交
442
# Use a subshell for each function, to give the optimal warning message.
443
include $(srcdir)/Makefile.nonreentrant
444 445 446 447
sc_prohibit_nonreentrant:
	@fail=0 ; \
	for i in $(NON_REENTRANT) ; \
	do \
E
Eric Blake 已提交
448 449 450 451
	    (prohibit="\\<$$i *\\("					\
	     halt="use $${i}_r, not $$i"				\
	     $(_sc_search_regexp)					\
	    ) || fail=1;						\
452 453 454
	done ; \
	exit $$fail

455 456 457 458 459
sc_prohibit_select:
	@prohibit="\\<select *\\("					\
	halt="use poll(), not se""lect()"				\
	  $(_sc_search_regexp)

460 461
# Prohibit the inclusion of <ctype.h>.
sc_prohibit_ctype_h:
E
Eric Blake 已提交
462 463
	@prohibit='^# *include  *<ctype\.h>'				\
	halt="don't use ctype.h; instead, use c-ctype.h"		\
464
	  $(_sc_search_regexp)
465

466 467 468 469 470 471
# Insist on correct types for [pug]id.
sc_correct_id_types:
	@prohibit='\<(int|long) *[pug]id\>'				\
	halt="use pid_t for pid, uid_t for uid, gid_t for gid"		\
	  $(_sc_search_regexp)

472 473 474
# "const fooPtr a" is the same as "foo * const a", even though it is
# usually desired to have "foo const *a".  It's easier to just prevent
# the confusing mix of typedef vs. const placement.
475
# Also requires that all 'fooPtr' typedefs are actually pointers.
476 477 478 479
sc_forbid_const_pointer_typedef:
	@prohibit='(^|[^"])const \w*Ptr'				\
	halt='"const fooPtr var" does not declare what you meant'	\
	  $(_sc_search_regexp)
480 481 482
	@prohibit='typedef [^(]+ [^*]\w*Ptr\b'				\
	halt='use correct style and type for Ptr typedefs'		\
	  $(_sc_search_regexp)
483

484 485 486 487 488 489
# Forbid sizeof foo or sizeof (foo), require sizeof(foo)
sc_size_of_brackets:
	@prohibit='sizeof\s'						\
	halt='use sizeof(foo), not sizeof (foo) or sizeof foo'		\
	  $(_sc_search_regexp)

E
Eric Blake 已提交
490
# Ensure that no C source file, docs, or rng schema uses TABs for
D
David Allan 已提交
491 492
# indentation.  Also match *.h.in files, to get libvirt.h.in.  Exclude
# files in gnulib, since they're imported.
493
space_indent_files=(\.(rng|s?[ch](\.in)?|html.in|py|pl|syms)|(daemon|tools)/.*\.in)
494
sc_TAB_in_indentation:
E
Eric Blake 已提交
495
	@prohibit='^ *	'						\
496
	in_vc_files='$(space_indent_files)$$'				\
497
	halt='indent with space, not TAB, in C, sh, html, py, syms and RNG schemas' \
498
	  $(_sc_search_regexp)
499 500 501 502 503

ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
|isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper

sc_avoid_ctype_macros:
E
Eric Blake 已提交
504 505
	@prohibit='\b($(ctype_re)) *\('					\
	halt="don't use ctype macros (use c-ctype.h)"			\
506
	  $(_sc_search_regexp)
507

508 509 510 511 512
sc_avoid_strcase:
	@prohibit='\bstrn?case(cmp|str) *\('				\
	halt="don't use raw strcase functions (use c-strcase instead)"	\
	  $(_sc_search_regexp)

513
sc_prohibit_virBufferAdd_with_string_literal:
E
Eric Blake 已提交
514 515 516
	@prohibit='\<virBufferAdd *\([^,]+, *"[^"]'			\
	halt='use virBufferAddLit, not virBufferAdd, with a string literal' \
	  $(_sc_search_regexp)
517

518 519 520 521 522
sc_prohibit_virBufferAsprintf_with_string_literal:
	@prohibit='\<virBufferAsprintf *\([^,]+, *"([^%"\]|\\.|%%)*"\)'		\
	halt='use virBufferAddLit, not virBufferAsprintf, with a string literal' \
	  $(_sc_search_regexp)

523 524 525 526 527
sc_forbid_manual_xml_indent:
	@prohibit='virBuffer.*" +<'					      \
	halt='use virBufferAdjustIndent instead of spaces when indenting xml' \
	  $(_sc_search_regexp)

528 529 530
# Not only do they fail to deal well with ipv6, but the gethostby*
# functions are also not thread-safe.
sc_prohibit_gethostby:
E
Eric Blake 已提交
531 532 533
	@prohibit='\<gethostby(addr|name2?) *\('			\
	halt='use getaddrinfo, not gethostby*'				\
	  $(_sc_search_regexp)
534

535 536 537 538 539 540
# dirname and basename from <libgen.h> are not required to be thread-safe
sc_prohibit_libgen:
	@prohibit='( (base|dir)name *\(|include .libgen\.h)'		\
	halt='use functions from gnulib "dirname.h", not <libgen.h>'	\
	  $(_sc_search_regexp)

541 542 543 544 545 546
# raw xmlGetProp requires some nasty casts
sc_prohibit_xmlGetProp:
	@prohibit='\<xmlGetProp *\('					\
	halt='use virXMLPropString, not xmlGetProp'			\
	  $(_sc_search_regexp)

M
Martin Kletzander 已提交
547 548 549 550 551 552
# xml(ParseURI|SaveUri) doesn't handle IPv6 URIs well
sc_prohibit_xmlURI:
	@prohibit='\<xml(ParseURI|SaveUri) *\('				\
	halt='use virURI(Parse|Format), not xml(ParseURI|SaveUri)'	\
	  $(_sc_search_regexp)

553 554 555 556 557 558
# we don't want old old-style return with parentheses around argument
sc_prohibit_return_as_function:
	@prohibit='\<return *\(([^()]*(\([^()]*\)[^()]*)*)\) *;'    \
	halt='avoid extra () with return statements'                \
	  $(_sc_search_regexp)

559 560 561 562 563 564 565 566
# ATTRIBUTE_UNUSED should only be applied in implementations, not
# header declarations
sc_avoid_attribute_unused_in_header:
	@prohibit='^[^#]*ATTRIBUTE_UNUSED([^:]|$$)'			\
	in_vc_files='\.h$$'						\
	halt='use ATTRIBUTE_UNUSED in .c rather than .h files'		\
	  $(_sc_search_regexp)

567
sc_prohibit_int_ijk:
568
	@prohibit='\<(int|unsigned) ([^(=]* )*(i|j|k)\>(\s|,|;)'	\
569 570 571 572
	halt='use size_t, not int/unsigned int for loop vars i, j, k'	\
	  $(_sc_search_regexp)

sc_prohibit_loop_iijjkk:
573
	@prohibit='\<(int|unsigned) ([^=]+ )*(ii|jj|kk)\>(\s|,|;)'	\
E
Eric Blake 已提交
574
	halt='use i, j, k for loop iterators, not ii, jj, kk' 		\
575 576
	  $(_sc_search_regexp)

E
Eric Blake 已提交
577 578 579 580 581 582
# RHEL 5 gcc can't grok "for (int i..."
sc_prohibit_loop_var_decl:
	@prohibit='\<for *\(\w+[ *]+\w+'				\
	in_vc_files='\.[ch]$$'						\
	halt='declare loop iterators outside the for statement'		\
	  $(_sc_search_regexp)
E
Eric Blake 已提交
583 584 585 586 587 588

# Use 'bool', not 'int', when assigning true or false
sc_prohibit_int_assign_bool:
	@prohibit='\<int\>.*= *(true|false)'				\
	halt='use bool type for boolean values'				\
	  $(_sc_search_regexp)
589

590 591 592 593 594 595
# Many of the function names below came from this filter:
# git grep -B2 '\<_('|grep -E '\.c- *[[:alpha:]_][[:alnum:]_]* ?\(.*[,;]$' \
# |sed 's/.*\.c-  *//'|perl -pe 's/ ?\(.*//'|sort -u \
# |grep -vE '^(qsort|if|close|assert|fputc|free|N_|vir.*GetName|.*Unlock|virNodeListDevices|virHashRemoveEntry|freeaddrinfo|.*[fF]ree|xdrmem_create|xmlXPathFreeObject|virUUIDFormat|openvzSetProgramSentinal|polkit_action_unref)$'

msg_gen_function =
596
msg_gen_function += VIR_ERROR
597 598
msg_gen_function += lxcError
msg_gen_function += regerror
599 600
msg_gen_function += vah_error
msg_gen_function += vah_warning
601
msg_gen_function += virGenericReportError
602
msg_gen_function += virRaiseError
603
msg_gen_function += virReportError
604 605
msg_gen_function += virReportErrorHelper
msg_gen_function += virReportSystemError
606
msg_gen_function += xenapiSessionErrorHandler
607 608 609 610 611 612 613 614 615

# Uncomment the following and run "make syntax-check" to see diagnostics
# that are not yet marked for translation, but that need to be rewritten
# so that they are translatable.
# msg_gen_function += fprintf
# msg_gen_function += testError
# msg_gen_function += vshPrint
# msg_gen_function += vshError

616
func_or := $(shell echo $(msg_gen_function)|tr -s ' ' '|')
617 618 619 620 621 622 623 624
func_re := ($(func_or))

# Look for diagnostics that aren't marked for translation.
# This won't find any for which error's format string is on a separate line.
# The sed filters eliminate false-positives like these:
#    _("...: "
#    "%s", _("no storage vol w..."
sc_libvirt_unmarked_diagnostics:
E
Eric Blake 已提交
625 626
	@prohibit='\<$(func_re) *\([^"]*"[^"]*[a-z]{3}'			\
	exclude='_\('							\
627
	halt='found unmarked diagnostic(s)'				\
E
Eric Blake 已提交
628
	  $(_sc_search_regexp)
629 630
	@{ grep     -nE '\<$(func_re) *\(.*;$$' $$($(VC_LIST_EXCEPT));   \
	   grep -A1 -nE '\<$(func_re) *\(.*,$$' $$($(VC_LIST_EXCEPT)); } \
631
	   | $(SED) 's/_("\([^\"]\|\\.\)\+"//;s/[	 ]"%s"//'		\
632 633 634
	   | grep '[	 ]"' &&						\
	  { echo '$(ME): found unmarked diagnostic(s)' 1>&2;		\
	    exit 1; } || :
635

636 637 638 639 640 641 642 643 644 645 646 647 648 649
# Like the above, but prohibit a newline at the end of a diagnostic.
# This is subject to false positives partly because it naively looks for
# `\n"', which may not be the end of the string, and also because it takes
# two lines of context (the -A2) after the line with the function name.
# FIXME: this rule might benefit from a separate function list, in case
# there are functions to which this one applies but that do not get marked
# diagnostics.
sc_prohibit_newline_at_end_of_diagnostic:
	@grep -A2 -nE							\
	    '\<$(func_re) *\(' $$($(VC_LIST_EXCEPT))			\
	    | grep '\\n"'						\
	  && { echo '$(ME): newline at end of message(s)' 1>&2;		\
	    exit 1; } || :

650 651 652 653 654 655
# Look for diagnostics that lack a % in the format string, except that we
# allow VIR_ERROR to do this, and ignore functions that take a single
# string rather than a format argument.
sc_prohibit_diagnostic_without_format:
	@{ grep     -nE '\<$(func_re) *\(.*;$$' $$($(VC_LIST_EXCEPT));   \
	   grep -A2 -nE '\<$(func_re) *\(.*,$$' $$($(VC_LIST_EXCEPT)); } \
656
	   | $(SED) -rn -e ':l; /[,"]$$/ {N;b l;}'				 \
657 658 659 660 661 662
		-e '/(xenapiSessionErrorHandler|vah_(error|warning))/d'	 \
		-e '/\<$(func_re) *\([^"]*"([^%"]|"\n[^"]*")*"[,)]/p'	 \
           | grep -vE 'VIR_ERROR' &&					 \
	  { echo '$(ME): found diagnostic without %' 1>&2;		 \
	    exit 1; } || :

663
# The strings "" and "%s" should never be marked for translation.
664
# Files under tests/ and examples/ should not be translated.
665 666
sc_prohibit_useless_translation:
	@prohibit='_\("(%s)?"\)'					\
667 668 669 670 671
	halt='found useless translation'				\
	  $(_sc_search_regexp)
	@prohibit='\<N?_ *\('						\
	in_vc_files='^(tests|examples)/'				\
	halt='no translations in tests or examples'			\
672 673
	  $(_sc_search_regexp)

674 675 676 677
# When splitting a diagnostic across lines, ensure that there is a space
# or \n on one side of the split.
sc_require_whitespace_in_translation:
	@grep -n -A1 '"$$' $$($(VC_LIST_EXCEPT))   			\
678
	   | $(SED) -ne ':l; /"$$/ {N;b l;}; s/"\n[^"]*"/""/g; s/\\n/ /g'	\
679 680 681 682
		-e '/_(.*[^\ ]""[^\ ]/p' | grep . &&			\
	  { echo '$(ME): missing whitespace at line split' 1>&2;	\
	    exit 1; } || :

683 684
# Enforce recommended preprocessor indentation style.
sc_preprocessor_indentation:
685
	@if cppi --version >/dev/null 2>&1; then			\
686
	  $(VC_LIST_EXCEPT) | grep -E '\.[ch](\.in)?$$' | xargs cppi -a -c	\
687 688 689 690 691 692
	    || { echo '$(ME): incorrect preprocessor indentation' 1>&2;	\
		exit 1; };						\
	else								\
	  echo '$(ME): skipping test $@: cppi not installed' 1>&2;	\
	fi

693 694 695 696 697
# Enforce similar spec file indentation style, by running cppi on a
# (comment-only) C file that mirrors the same layout as the spec file.
sc_spec_indentation:
	@if cppi --version >/dev/null 2>&1; then			\
	  for f in $$($(VC_LIST_EXCEPT) | grep '\.spec\.in$$'); do	\
698
	    $(SED) -e 's|#|// #|; s|%ifn*\(arch\)* |#if a // |'		\
699 700 701
		-e 's/%\(else\|endif\|define\)/#\1/'			\
		-e 's/^\( *\)\1\1\1#/#\1/'				\
		-e 's|^\( *[^#/ ]\)|// \1|; s|^\( */[^/]\)|// \1|' $$f	\
702
	    | cppi -a -c 2>&1 | $(SED) "s|standard input|$$f|";		\
703 704 705 706 707 708 709
	  done | { if grep . >&2; then false; else :; fi; }		\
	    || { echo '$(ME): incorrect preprocessor indentation' 1>&2;	\
		exit 1; };						\
	else								\
	  echo '$(ME): skipping test $@: cppi not installed' 1>&2;	\
	fi

710 711 712 713 714 715 716 717
# Nested conditionals are easier to understand if we enforce that endifs
# can be paired back to the if
sc_makefile_conditionals:
	@prohibit='(else|endif)($$| *#)'				\
	in_vc_files='Makefile\.am'					\
	halt='match "if FOO" with "endif FOO" in Makefiles'		\
	  $(_sc_search_regexp)

E
Eric Blake 已提交
718 719 720 721 722 723 724 725
# Long lines can be harder to diff; too long, and git send-email chokes.
# For now, only enforce line length on files where we have intentionally
# fixed things and don't want to regress.
sc_prohibit_long_lines:
	@prohibit='.{90}'						\
	in_vc_files='\.arg[sv]'						\
	halt='Wrap long lines in expected output files'			\
	  $(_sc_search_regexp)
726 727 728 729
	@prohibit='.{80}'						\
	in_vc_files='Makefile\.am'					\
	halt='Wrap long lines in Makefiles'				\
	  $(_sc_search_regexp)
E
Eric Blake 已提交
730

731
sc_copyright_format:
E
Eric Blake 已提交
732 733 734
	@require='Copyright .*Red 'Hat', Inc\.'				\
	containing='Copyright .*Red 'Hat				\
	halt='Red Hat copyright is missing Inc.'			\
735
	  $(_sc_search_regexp)
E
Eric Blake 已提交
736 737
	@prohibit='Copyright [^(].*Red 'Hat				\
	halt='consistently use (C) in Red Hat copyright'		\
738
	  $(_sc_search_regexp)
E
Eric Blake 已提交
739 740 741
	@prohibit='\<Red''Hat\>'					\
	halt='spell Red Hat as two words'				\
	  $(_sc_search_regexp)
742

743
# Prefer the new URL listing over the old street address listing when
744 745 746 747 748 749
# calling out where to get a copy of the [L]GPL.  Also, while we have
# to ship COPYING (GPL) alongside COPYING.LESSER (LGPL), we want any
# source file that calls out a top-level file to call out the LGPL
# version.  Note that our typical copyright boilerplate refers to the
# license by name, not by reference to a top-level file.
sc_copyright_usage:
750 751 752
	@prohibit=Boston,' MA'						\
	halt='Point to <http://www.gnu.org/licenses/>, not an address'	\
	  $(_sc_search_regexp)
753 754 755 756 757 758 759
	@require='COPYING\.LESSER'					\
	containing='COPYING'						\
	halt='Refer to COPYING.LESSER for LGPL'				\
	  $(_sc_search_regexp)
	@prohibit='COPYING\.LIB'					\
	halt='Refer to COPYING.LESSER for LGPL'				\
	  $(_sc_search_regexp)
760

761 762 763
# Some functions/macros produce messages intended solely for developers
# and maintainers.  Do not mark them for translation.
sc_prohibit_gettext_markup:
764
	@prohibit='\<VIR_(WARN|INFO|DEBUG) *\(_\('			\
765 766
	halt='do not mark these strings for translation'		\
	  $(_sc_search_regexp)
767

E
Eric Blake 已提交
768 769 770 771
# Our code is divided into modular subdirectories for a reason, and
# lower-level code must not include higher-level headers.
cross_dirs=$(patsubst $(srcdir)/src/%.,%,$(wildcard $(srcdir)/src/*/.))
cross_dirs_re=($(subst / ,/|,$(cross_dirs)))
772
mid_dirs=access|conf|cpu|locking|network|node_device|rpc|security|storage
E
Eric Blake 已提交
773 774 775 776
sc_prohibit_cross_inclusion:
	@for dir in $(cross_dirs); do					\
	  case $$dir in							\
	    util/) safe="util";;					\
777 778 779
	    access/ | conf/) safe="($$dir|conf|util)";;			\
	    locking/) safe="($$dir|util|conf|rpc)";;			\
	    cpu/| network/| node_device/| rpc/| security/| storage/)	\
780
	      safe="($$dir|util|conf|storage)";;			\
J
Jim Fehlig 已提交
781
	    xenapi/ | xenconfig/ ) safe="($$dir|util|conf|xen)";;	\
782
	    *) safe="($$dir|$(mid_dirs)|util)";;			\
E
Eric Blake 已提交
783 784 785 786 787 788 789 790
	  esac;								\
	  in_vc_files="^src/$$dir"					\
	  prohibit='^# *include .$(cross_dirs_re)'			\
	  exclude="# *include .$$safe"					\
	  halt='unsafe cross-directory include'				\
	    $(_sc_search_regexp)					\
	done

E
Eric Blake 已提交
791 792 793 794
# When converting an enum to a string, make sure that we track any new
# elements added to the enum by using a _LAST marker.
sc_require_enum_last_marker:
	@grep -A1 -nE '^[^#]*VIR_ENUM_IMPL *\(' $$($(VC_LIST_EXCEPT))	\
795
	   | $(SED) -ne '/VIR_ENUM_IMPL[^,]*,$$/N'				\
E
Eric Blake 已提交
796 797 798 799 800 801
	     -e '/VIR_ENUM_IMPL[^,]*,[^,]*[^_,][^L,][^A,][^S,][^T,],/p'	\
	     -e '/VIR_ENUM_IMPL[^,]*,[^,]\{0,4\},/p'			\
	   | grep . &&							\
	  { echo '$(ME): enum impl needs to use _LAST marker' 1>&2;	\
	    exit 1; } || :

802 803 804 805 806 807 808
# In Python files we don't want to end lines with a semicolon like in C
sc_prohibit_semicolon_at_eol_in_python:
	@prohibit='^[^#].*\;$$'			                        \
	in_vc_files='\.py$$'						\
	halt="Don't use semicolon at eol in python files"		\
	  $(_sc_search_regexp)

809 810 811 812 813 814 815
# mymain() in test files should use return, not exit, for nicer output
sc_prohibit_exit_in_tests:
	@prohibit='\<exit *\('						\
	in_vc_files='^tests/'						\
	halt='use return, not exit(), in tests'				\
	  $(_sc_search_regexp)

816 817 818 819 820 821 822 823 824 825 826 827 828 829 830 831 832 833 834 835 836
# Don't include duplicate header in the source (either *.c or *.h)
sc_prohibit_duplicate_header:
	@fail=0; for i in $$($(VC_LIST_EXCEPT) | grep '\.[chx]$$'); do	\
	  awk '/# *include.*\.h/ {					\
	    match($$0, /[<"][^>"]*[">]/);				\
	    arr[substr($$0, RSTART + 1, RLENGTH - 2)]++;		\
	  }								\
	  END {								\
	    for (key in arr) {						\
	      if (arr[key] > 1)	{					\
		fail=1;							\
		printf("%d %s are included\n", arr[key], key);		\
	      }								\
	    }								\
	    if (fail == 1) {						\
	      printf("duplicate header(s) in " FILENAME "\n");		\
	      exit 1;							\
	    }								\
	  }' $$i || fail=1;						\
	done;								\
	if test $$fail -eq 1; then					\
837
	  { echo '$(ME): avoid duplicate headers' 1>&2; exit 1; }	\
838 839
	fi;

840
# Don't include "libvirt/*.h" in "" form.
841
sc_prohibit_include_public_headers_quote:
842
	@prohibit='# *include *"libvirt/.*\.h"'				\
843 844 845 846 847 848 849 850 851
	in_vc_files='\.[ch]$$'						\
	halt='Do not include libvirt/*.h in internal source'		\
	  $(_sc_search_regexp)

# Don't include "libvirt/*.h" in <> form. Except for external tools,
# e.g. Python binding, examples and tools subdirectories.
sc_prohibit_include_public_headers_brackets:
	@prohibit='# *include *<libvirt/.*\.h>'				\
	in_vc_files='\.[ch]$$'						\
852 853 854
	halt='Do not include libvirt/*.h in internal source'		\
	  $(_sc_search_regexp)

855 856 857 858 859 860 861 862
# <config.h> is only needed in .c files; .h files do not need it since
# .c files must include config.h before any other .h.
sc_prohibit_config_h_in_headers:
	@prohibit='^# *include\>.*config\.h'				\
	in_vc_files='\.h$$'						\
	halt='headers should not include <config.h>'			\
	  $(_sc_search_regexp)

863 864 865 866 867 868
sc_prohibit_unbounded_arrays_in_rpc:
	@prohibit='<>'							\
	in_vc_files='\.x$$'						\
	halt='Arrays in XDR must have a upper limit set for <NNN>'	\
	  $(_sc_search_regexp)

869 870 871 872 873
sc_prohibit_getenv:
	@prohibit='\b(secure_)?getenv *\('				\
	exclude='exempt from syntax-check'				\
	halt='Use virGetEnv{Allow,Block}SUID instead of getenv'		\
	  $(_sc_search_regexp)
874

P
Peter Krempa 已提交
875 876 877 878 879
sc_prohibit_atoi:
	@prohibit='\bato(i|f|l|ll|q) *\('	\
	halt='Use virStrToLong* instead of atoi, atol, atof, atoq, atoll' \
	  $(_sc_search_regexp)

880 881 882 883 884 885 886 887 888 889 890 891 892 893 894 895 896 897 898 899
sc_prohibit_wrong_filename_in_comment:
	@fail=0;                                                       \
	awk 'BEGIN {                                                   \
	  fail=0;                                                      \
	} FNR < 3 {                                                    \
	  n=match($$0, /[[:space:]][^[:space:]]*[.][ch][[:space:]:]/); \
	  if (n > 0) {                                                 \
	    A=substr($$0, RSTART+1, RLENGTH-2);                        \
	    n=split(FILENAME, arr, "/");                               \
	    if (A != arr[n]) {                                         \
	      print "in " FILENAME ": " A " mentioned in comments ";   \
	      fail=1;                                                  \
	    }                                                          \
	  }                                                            \
	} END {                                                        \
	  if (fail == 1) {                                             \
	    exit 1;                                                    \
	  }                                                            \
	}' $$($(VC_LIST_EXCEPT) | grep '\.[ch]$$') || fail=1;          \
	if test $$fail -eq 1; then                                     \
900
	  { echo '$(ME): The file name in comments must match the'     \
901 902 903
	    'actual file name' 1>&2; exit 1; }	                       \
	fi;

904
sc_prohibit_virConnectOpen_in_virsh:
M
Martin Kletzander 已提交
905 906 907
	@prohibit='\bvirConnectOpen[a-zA-Z]* *\('                      \
	in_vc_files='^tools/virsh-.*\.[ch]$$'                          \
	halt='Use vshConnect() in virsh instead of virConnectOpen*'    \
908 909
	  $(_sc_search_regexp)

J
Ján Tomko 已提交
910 911 912 913 914 915
sc_require_space_before_label:
	@prohibit='^(   ?)?[_a-zA-Z0-9]+:$$'                           \
	in_vc_files='\.[ch]$$'                                         \
	halt="Top-level labels should be indented by one space"        \
	  $(_sc_search_regexp)

916 917 918 919 920 921 922
# Doesn't catch all cases of mismatched braces across if-else, but it helps
sc_require_if_else_matching_braces:
	@prohibit='(  else( if .*\))? {|} else( if .*\))?$$)'		\
	in_vc_files='\.[chx]$$'						\
	halt="if one side of if-else uses {}, both sides must use it"	\
	  $(_sc_search_regexp)

923
sc_curly_braces_style:
924 925 926 927 928 929 930 931 932 933 934 935
	@files=$$($(VC_LIST_EXCEPT) | grep '\.[ch]$$');			\
	if $(GREP) -nHP							\
'^\s*(?!([a-zA-Z_]*for_?each[a-zA-Z_]*) ?\()([_a-zA-Z0-9]+( [_a-zA-Z0-9]+)* ?\()?(\*?[_a-zA-Z0-9]+(,? \*?[_a-zA-Z0-9\[\]]+)+|void)\) ?\{'		\
	$$files; then							\
	  echo '$(ME): Non-K&R style used for curly braces around'	\
		'function body, see HACKING' 1>&2; exit 1;		\
	fi;								\
	if $(GREP) -A1 -En ' ((if|for|while|switch) \(|(else|do)\b)[^{]*$$'\
	  $$files | $(GREP) '^[^ ]*- *{'; then				\
	  echo '$(ME): Use hanging braces for compound statements,'	\
		'see HACKING' 1>&2; exit 1;				\
	fi
P
Peter Krempa 已提交
936

937 938 939 940 941
sc_prohibit_windows_special_chars_in_filename:
	@files=$$($(VC_LIST_EXCEPT) | grep '[:*?"<>|]');               \
	test -n "$$files" && { echo '$(ME): Windows special chars'     \
	  'in filename not allowed:' 1>&2; echo $$files 1>&2; exit 1; } || :

942 943 944 945 946 947
sc_prohibit_mixed_case_abbreviations:
	@prohibit='Pci|Usb|Scsi'			\
	in_vc_files='\.[ch]$$'				\
	halt='Use PCI, USB, SCSI, not Pci, Usb, Scsi'	\
	  $(_sc_search_regexp)

948 949
# Require #include <locale.h> in all files that call setlocale()
sc_require_locale_h:
950 951 952 953
	@require='include.*locale\.h'					\
	containing='setlocale *('					\
	halt='setlocale() requires <locale.h>'				\
	  $(_sc_search_regexp)
954

955 956 957 958 959 960 961
sc_prohibit_empty_first_line:
	@awk 'BEGIN { fail=0; }						\
	FNR == 1 { if ($$0 == "") { print FILENAME ":1:"; fail=1; } }	\
	END { if (fail == 1) {						\
	  print "$(ME): Prohibited empty first line" > "/dev/stderr";	\
	} exit fail; }' $$($(VC_LIST_EXCEPT));

962 963 964 965 966 967
sc_prohibit_paren_brace:
	@prohibit='\)\{$$'						\
	in_vc_files='\.[chx]$$'						\
	halt='Put space between closing parenthesis and opening brace'	\
	  $(_sc_search_regexp)

968 969 970 971 972 973 974 975
# C guarantees that static variables are zero initialized, and some compilers
# waste space by sticking explicit initializers in .data instead of .bss
sc_prohibit_static_zero_init:
	@prohibit='\bstatic\b.*= *(0[^xX0-9]|NULL|false)'		\
	in_vc_files='\.[chx](\.in)?$$'					\
	halt='static variables do not need explicit zero initialization'\
	  $(_sc_search_regexp)

976 977 978 979 980 981 982
# FreeBSD exports the "devname" symbol which produces a warning.
sc_prohibit_devname:
	@prohibit='\bdevname\b'	\
	exclude='sc_prohibit_devname' \
	halt='avoid using 'devname' as FreeBSD exports the symbol' \
	  $(_sc_search_regexp)

J
Jiri Denemark 已提交
983 984 985 986 987
sc_prohibit_system_error_with_vir_err:
	@prohibit='\bvirReportSystemError *\(VIR_ERR_' \
	halt='do not use virReportSystemError with VIR_ERR_* error codes' \
	  $(_sc_search_regexp)

988 989 990 991
# Rule to prohibit usage of virXXXFree within library, daemon, remote, etc.
# functions. There's a corresponding exclude to allow usage within tests,
# docs, examples, tools, src/libvirt-*.c, and include/libvirt/libvirt-*.h
sc_prohibit_virXXXFree:
992
	@prohibit='\bvir(Domain|Network|NodeDevice|StorageVol|StoragePool|Stream|Secret|NWFilter|Interface|DomainSnapshot)Free\b'	\
993 994 995 996
	exclude='sc_prohibit_virXXXFree' \
	halt='avoid using 'virXXXFree', use 'virObjectUnref' instead' \
	  $(_sc_search_regexp)

997 998 999 1000 1001
sc_prohibit_sysconf_pagesize:
	@prohibit='sysconf\(_SC_PAGESIZE' \
	halt='use virGetSystemPageSize[KB] instead of sysconf(_SC_PAGESIZE)' \
	  $(_sc_search_regexp)

1002 1003
# We don't use this feature of maint.mk.
prev_version_file = /dev/null
1004

1005
ifneq ($(_gl-Makefile),)
1006 1007
ifeq (0,$(MAKELEVEL))
  _curr_status = .git-module-status
1008 1009 1010 1011 1012 1013
  # The sed filter accommodates those who check out on a commit from which
  # no tag is reachable.  In that case, git submodule status prints a "-"
  # in column 1 and does not print a "git describe"-style string after the
  # submodule name.  Contrast these:
  # -b653eda3ac4864de205419d9f41eec267cb89eeb .gnulib
  #  b653eda3ac4864de205419d9f41eec267cb89eeb .gnulib (v0.0-2286-gb653eda)
1014 1015
  # $ cat .git-module-status
  # b653eda3ac4864de205419d9f41eec267cb89eeb
1016 1017
  #
  # Keep this logic in sync with autogen.sh.
1018
  _submodule_hash = $(SED) 's/^[ +-]//;s/ .*//'
1019
  _update_required := $(shell						\
1020
      cd '$(srcdir)';							\
1021
      test -d .git || { echo 0; exit; };				\
1022
      test -f po/Makevars || { echo 1; exit; };				\
1023
      test -f AUTHORS || { echo 1; exit; };				\
E
Eric Blake 已提交
1024
      test "no-git" = "$$(cat $(_curr_status))" && { echo 0; exit; };	\
1025
      actual=$$(git submodule status | $(_submodule_hash);		\
1026
		git hash-object bootstrap.conf;				\
E
Eric Blake 已提交
1027
		git ls-tree -d HEAD gnulib/local | awk '{print $$3}';	\
1028
		git diff .gnulib);					\
1029 1030
      stamp="$$($(_submodule_hash) $(_curr_status) 2>/dev/null)";	\
      test "$$stamp" = "$$actual"; echo $$?)
1031 1032
  _clean_requested = $(filter %clean,$(MAKECMDGOALS))
  ifeq (1,$(_update_required)$(_clean_requested))
1033
    $(info INFO: gnulib update required; running ./autogen.sh first)
C
Cole Robinson 已提交
1034
    $(shell touch $(srcdir)/AUTHORS $(srcdir)/ChangeLog)
E
Eric Blake 已提交
1035
maint.mk Makefile: _autogen
1036 1037
  endif
endif
1038
endif
1039

E
Eric Blake 已提交
1040 1041 1042 1043 1044 1045 1046
# It is necessary to call autogen any time gnulib changes.  Autogen
# reruns configure, then we regenerate all Makefiles at once.
.PHONY: _autogen
_autogen:
	$(srcdir)/autogen.sh
	./config.status

1047
# regenerate HACKING as part of the syntax-check
1048
ifneq ($(_gl-Makefile),)
1049
syntax-check: $(top_srcdir)/HACKING bracket-spacing-check
1050
endif
1051 1052 1053 1054

bracket-spacing-check:
	$(AM_V_GEN)files=`$(VC_LIST) | grep '\.c$$'`; \
	$(PERL) $(top_srcdir)/build-aux/bracket-spacing.pl $$files || \
1055
	  { echo '$(ME): incorrect formatting, see HACKING for rules' 1>&2; \
1056
	    exit 1; }
1057

1058
# sc_po_check can fail if generated files are not built first
1059 1060 1061
sc_po_check: \
		$(srcdir)/daemon/remote_dispatch.h \
		$(srcdir)/daemon/qemu_dispatch.h \
1062
		$(srcdir)/src/remote/remote_client_bodies.h
1063
$(srcdir)/daemon/remote_dispatch.h: $(srcdir)/src/remote/remote_protocol.x
1064
	$(MAKE) -C daemon remote_dispatch.h
1065 1066 1067
$(srcdir)/daemon/qemu_dispatch.h: $(srcdir)/src/remote/qemu_protocol.x
	$(MAKE) -C daemon qemu_dispatch.h
$(srcdir)/src/remote/remote_client_bodies.h: $(srcdir)/src/remote/remote_protocol.x
1068 1069
	$(MAKE) -C src remote/remote_client_bodies.h

1070
# List all syntax-check exemptions:
1071
exclude_file_name_regexp--sc_avoid_strcase = ^tools/virsh\.h$$
1072

1073
_src1=libvirt-stream|fdstream|qemu/qemu_monitor|util/(vircommand|virfile)|xen/xend_internal|rpc/virnetsocket|lxc/lxc_controller|locking/lock_daemon
1074
_test1=shunloadtest|virnettlscontexttest|virnettlssessiontest|vircgroupmock
1075
exclude_file_name_regexp--sc_avoid_write = \
1076
  ^(src/($(_src1))|daemon/libvirtd|tools/virsh-console|tests/($(_test1)))\.c$$
1077 1078 1079

exclude_file_name_regexp--sc_bindtextdomain = ^(tests|examples)/

1080
exclude_file_name_regexp--sc_copyright_usage = \
1081
  ^COPYING(|\.LESSER)$$
1082

1083 1084
exclude_file_name_regexp--sc_flags_usage = \
  ^(docs/|src/util/virnetdevtap\.c$$|tests/vir(cgroup|pci|usb)mock\.c$$)
1085

1086
exclude_file_name_regexp--sc_libvirt_unmarked_diagnostics = \
1087
  ^(src/rpc/gendispatch\.pl$$|tests/)
1088

1089
exclude_file_name_regexp--sc_po_check = ^(docs/|src/rpc/gendispatch\.pl$$)
1090 1091

exclude_file_name_regexp--sc_prohibit_VIR_ERR_NO_MEMORY = \
1092
  ^(include/libvirt/virterror\.h|daemon/dispatch\.c|src/util/virerror\.c|docs/internals/oomtesting\.html\.in)$$
1093

1094
exclude_file_name_regexp--sc_prohibit_access_xok = ^src/util/virutil\.c$$
E
Eric Blake 已提交
1095

1096
exclude_file_name_regexp--sc_prohibit_asprintf = \
1097
  ^(bootstrap.conf$$|src/util/virstring\.[ch]$$|tests/vircgroupmock\.c$$)
E
Eric Blake 已提交
1098

1099
exclude_file_name_regexp--sc_prohibit_strdup = \
1100
  ^(docs/|examples/|src/util/virstring\.c|tests/vir(netserverclient|cgroup)mock.c$$)
1101

1102
exclude_file_name_regexp--sc_prohibit_close = \
1103
  (\.p[yl]$$|\.spec\.in$$|^docs/|^(src/util/virfile\.c|src/libvirt-stream\.c|tests/vir(cgroup|pci)mock\.c)$$)
1104 1105

exclude_file_name_regexp--sc_prohibit_empty_lines_at_EOF = \
1106
  (^tests/(qemuhelp|nodeinfo|virpcitest)data/|\.diff$$)
1107

1108
_src2=src/(util/vircommand|libvirt|lxc/lxc_controller|locking/lock_daemon)
1109
exclude_file_name_regexp--sc_prohibit_fork_wrappers = \
1110
  (^($(_src2)|tests/testutils|daemon/libvirtd)\.c$$)
1111

1112
exclude_file_name_regexp--sc_prohibit_gethostname = ^src/util/virutil\.c$$
1113

E
Eric Blake 已提交
1114
exclude_file_name_regexp--sc_prohibit_internal_functions = \
1115
  ^src/(util/(viralloc|virutil|virfile)\.[hc]|esx/esx_vi\.c)$$
E
Eric Blake 已提交
1116

1117
exclude_file_name_regexp--sc_prohibit_newline_at_end_of_diagnostic = \
1118
  ^src/rpc/gendispatch\.pl$$
1119

1120
exclude_file_name_regexp--sc_prohibit_nonreentrant = \
1121
  ^((po|tests)/|docs/.*(py|html\.in)|run.in$$|tools/wireshark/util/genxdrstub\.pl$$)
1122

E
Eric Blake 已提交
1123
exclude_file_name_regexp--sc_prohibit_raw_allocation = \
1124
  ^(docs/hacking\.html\.in|src/util/viralloc\.[ch]|examples/.*|tests/(securityselinuxhelper|vircgroupmock)\.c|tools/wireshark/src/packet-libvirt\.c)$$
E
Eric Blake 已提交
1125

1126
exclude_file_name_regexp--sc_prohibit_readlink = \
1127
  ^src/(util/virutil|lxc/lxc_container)\.c$$
1128

1129
exclude_file_name_regexp--sc_prohibit_setuid = ^src/util/virutil\.c$$
E
Eric Blake 已提交
1130

1131
exclude_file_name_regexp--sc_prohibit_sprintf = \
1132
  (^docs/hacking\.html\.in|\.stp|\.pl)$$
1133

1134
exclude_file_name_regexp--sc_prohibit_strncpy = ^src/util/virstring\.c$$
1135

1136
exclude_file_name_regexp--sc_prohibit_strtol = ^examples/dom.*/.*\.c$$
E
Eric Blake 已提交
1137

1138
exclude_file_name_regexp--sc_prohibit_xmlGetProp = ^src/util/virxml\.c$$
1139

M
Martin Kletzander 已提交
1140 1141
exclude_file_name_regexp--sc_prohibit_xmlURI = ^src/util/viruri\.c$$

1142 1143
exclude_file_name_regexp--sc_prohibit_return_as_function = \.py$$

1144 1145
exclude_file_name_regexp--sc_require_config_h = \
	^(examples/|tools/virsh-edit\.c$$)
1146

1147 1148
exclude_file_name_regexp--sc_require_config_h_first = \
	^(examples/|tools/virsh-edit\.c$$)
1149

1150
exclude_file_name_regexp--sc_trailing_blank = \
1151
  /qemuhelpdata/|/sysinfodata/.*\.data|/nodeinfodata/.*\.cpuinfo$$
1152 1153 1154

exclude_file_name_regexp--sc_unmarked_diagnostics = \
  ^(docs/apibuild.py|tests/virt-aa-helper-test)$$
1155 1156

exclude_file_name_regexp--sc_size_of_brackets = cfg.mk
1157 1158 1159

exclude_file_name_regexp--sc_correct_id_types = \
  (^src/locking/lock_protocol.x$$)
1160 1161

exclude_file_name_regexp--sc_m4_quote_check = m4/virt-lib.m4
1162

1163
exclude_file_name_regexp--sc_prohibit_include_public_headers_quote = \
1164
  ^(src/internal\.h$$|tools/wireshark/src/packet-libvirt.h$$)
1165 1166

exclude_file_name_regexp--sc_prohibit_include_public_headers_brackets = \
D
Daniel P. Berrange 已提交
1167
  ^(tools/|examples/|include/libvirt/(virterror|libvirt-(qemu|lxc))\.h$$)
1168 1169 1170

exclude_file_name_regexp--sc_prohibit_int_ijk = \
  ^(src/remote_protocol-structs|src/remote/remote_protocol.x|cfg.mk|include/)$
1171 1172 1173

exclude_file_name_regexp--sc_prohibit_getenv = \
  ^tests/.*\.[ch]$$
1174 1175 1176

exclude_file_name_regexp--sc_avoid_attribute_unused_in_header = \
  ^src/util/virlog\.h$$
1177 1178 1179

exclude_file_name_regexp--sc_prohibit_mixed_case_abbreviations = \
  ^src/(vbox/vbox_CAPI.*.h|esx/esx_vi.(c|h)|esx/esx_storage_backend_iscsi.c)$$
1180 1181

exclude_file_name_regexp--sc_prohibit_empty_first_line = \
1182
  ^(README|daemon/THREADS\.txt|src/esx/README|docs/library.xen|tests/vmwareverdata/fusion-5.0.3.txt|tests/nodeinfodata/linux-raspberrypi/cpu/offline)$$
1183 1184 1185

exclude_file_name_regexp--sc_prohibit_useless_translation = \
  ^tests/virpolkittest.c
1186 1187 1188

exclude_file_name_regexp--sc_prohibit_devname = \
  ^(tools/virsh.pod|cfg.mk|docs/.*)$$
1189 1190

exclude_file_name_regexp--sc_prohibit_virXXXFree = \
1191
  ^(docs/|tests/|examples/|tools/|cfg.mk|src/test/test_driver.c|src/libvirt_public.syms|include/libvirt/libvirt-(domain|network|nodedev|storage|stream|secret|nwfilter|interface|domain-snapshot).h|src/libvirt-(domain|qemu|network|nodedev|storage|stream|secret|nwfilter|interface|domain-snapshot).c$$)
1192 1193 1194

exclude_file_name_regexp--sc_prohibit_sysconf_pagesize = \
  ^(cfg\.mk|src/util/virutil\.c)$$